SystemOrganization addCategory: #SmalltalkQuiz!

Object subclass: #SmalltalkQuiz
	instanceVariableNames: 'answer choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:39'!
answer

	^answer! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:35'!
beOne

	| subclasses classes wrongCandidates wrongOne |
	classes := Smalltalk allClasses.
	answer :=classes atRandom.
	subclasses := answer allSubclasses.
	subclasses isEmpty ifTrue: [^false].
	wrongCandidates := classes copyWithoutAll: subclasses.
	choices := OrderedCollection new.
	choices add: subclasses atRandom.
	wrongOne := wrongCandidates atRandom.
	choices add: (wrongCandidates remove:wrongOne).
	wrongOne := wrongCandidates atRandom.
	choices add: (wrongCandidates remove:wrongOne).
	wrongOne := wrongCandidates atRandom.
	choices add: (wrongCandidates remove:wrongOne).
	choices := choices shuffled.
	^true! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:26'!
choices

	^choices! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:49'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:46'!
correctChoice

	| correctOne |
	correctOne := self choices select: [:each| each inheritsFrom: self answer].
	self assert: [correctOne size = 1 ].
	^correctOne anyOne! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:52'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:51'!
questionString

	^'Which one of the classes below is subclass of ', answer asString , '?'! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:30'!
runToGetOne

	[self beOne] whileFalse! !
